\begin{tikzpicture}[
	service/.style={circle, draw, fill=fg!90!bg, text=bg},
	parallel/.style={draw, rectangle, node contents={}, minimum height=4em, inner sep=0pt, text width=0pt, fill},
	qos/.style={rounded corners, callout pointer shorten=-2pt, rectangle callout, fill=structure.bg, text=structure.fg, draw, callout absolute pointer=#1, fill opacity=.6, text opacity=1},
	formula/.style={anchor=west},
	->, align=center
]
	\node (a) at (0, 0) [service] {a4};
	\node (p1) at (1, 0) [parallel];
	\node (b) at (2, .6) [service] {\alt<4>{\alert{b3}}{b2}};
	\node (c) at (2, -.6) [service] {c1};
	\node (p2) at (3, 0) [parallel];

	\draw (-1, 0) -- (a);
	\draw (a) -- (p1);
	\draw (p1 |- b) -- (b);
	\draw (p1 |- c) -- (c);
	\draw (b) -- (b -| p2);
	\draw (c) -- (c -| p2);
	\draw (p2) -- (3.5, 0);

	\onslide<2->{
		\node (qa) at (-.5, 1.5) [qos=(a.north)] {$c = 4$\\$l = 1$};
		\node (qb) at (1, 2) [qos=(b.north west)] {$c = \alt<4>{\alert{2}}{3}$\\$l = \alt<4>{\alert{4}}{2}$};
		\node (qc) at (3, 2) [qos=(c.north east)] {$c = 1$\\$l = 5$};
	}
	\onslide<3->{
		\draw[rounded corners] (4, -.9) rectangle (7.9, .9);
		\node (cost) at (4, .5) [formula] {$c = 4 + \alt<4>{\alert{2}}{3} + 1 = \alt<4>{\alert{7}}{8}$};
		\node (latency) at (4, -.5) [formula] {$l = 1 + \text{max}\{\alt<4>{\alert{4}}{2}, 5\} = 6$};
	}
\end{tikzpicture}